// PrinterCtrl.cpp:  Implementation of CSubThread CPrinterCtrl
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
//#include "StarCmdInstaller.h"
#include "PrinterCtrl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Constructor/Destructor
//////////////////////////////////////////////////////////////////////

CPrinterCtrl::CPrinterCtrl()
{
	ClearAllMember();	// Initializing all member
}

CPrinterCtrl::~CPrinterCtrl()
{

}

//
// enumerates available printers to PrinterList
//
BOOL CPrinterCtrl::EnumPrinters()
{
	BOOL 			myRes		= FALSE;
	LPBYTE			pBuf		= NULL;
	LPBYTE			pBuf0		= NULL;
	DWORD			cbNeeded	= 0;
	DWORD			cReturned	= 0;
	DWORD			i			= 0;
	int				m			= 0;
	PRINTER_INFO	PrinterInfo;
	PRINTER_INFO_2 *pPrinterInfo2 = NULL;

	// deletes all printer information
	PrinterList.RemoveAll();

	// allocate buffer for PRINATER_INFO_2
	myRes = ::EnumPrinters(
				PRINTER_ENUM_LOCAL,		// DWORD Flags,         // printer object types
				NULL,					// LPTSTR Name,         // name of printer object
				2,						// DWORD Level,         // information level
				NULL,					// LPBYTE pPrinterEnum, // printer information buffer
				0,						// DWORD cbBuf,         // size of printer information buffer
				&cbNeeded,				// LPDWORD pcbNeeded,   // bytes received or required
				&cReturned				// LPDWORD pcReturned   // number of printers enumerated
			);


	pBuf = (LPBYTE)malloc(cbNeeded);
	if (!pBuf){
		m_GetErrorMsg();
		return FALSE;
	}

	// enumerates available printers PRINATER_INFO_2
	myRes = ::EnumPrinters(
				PRINTER_ENUM_LOCAL,		// DWORD Flags,         // printer object types
				NULL,					// LPTSTR Name,         // name of printer object
				2,						// DWORD Level,         // information level
				pBuf,					// LPBYTE pPrinterEnum, // printer information buffer
				cbNeeded,				// DWORD cbBuf,         // size of printer information buffer
				&cbNeeded,				// LPDWORD pcbNeeded,   // bytes received or required
				&cReturned				// LPDWORD pcReturned   // number of printers enumerated
			);

	if (!myRes){
		free(pBuf);
		m_GetErrorMsg();
		return FALSE;
	}
	if (cReturned <= 0){
		free(pBuf);
		m_GetErrorMsg();
		return FALSE;
	}
	
	pBuf0 = pBuf;
	
	for ( i = 0; i < cReturned; i++){
		pPrinterInfo2 = (PRINTER_INFO_2 *)pBuf0;
		PrinterInfo.PrinterName.Format(_T("%s"),pPrinterInfo2->pPrinterName);
		PrinterInfo.PortName.Format(_T("%s"),pPrinterInfo2->pPortName);
		PrinterInfo.ModelName.Format(_T("%s"),pPrinterInfo2->pDriverName);
		PrinterList.AddTail(PrinterInfo);
		pBuf0 += sizeof(PRINTER_INFO_2);
	};

	free(pBuf);
	m_ClearErrorMsg();
	return TRUE;
}


void CPrinterCtrl::ClearAllMember()
{
	TargetPrinterName	= "";
	DataFileName		= "";
	PrinterList.RemoveAll();
	m_ClearErrorMsg();
}


///////////////////////////////////////////////////////////////
// making error message
//
void CPrinterCtrl::m_GetErrorMsg()
{
	BYTE	MsgBuf[255];
	int		bufSize = 250;

	FormatMessage(
//		FORMAT_MESSAGE_ALLOCATE_BUFFER |
		FORMAT_MESSAGE_FROM_SYSTEM |
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // language
		(LPTSTR) MsgBuf,
		bufSize,
		NULL
	);
	m_LastErrorStr = (LPCTSTR)MsgBuf;

	return;
}


///////////////////////////////////////////////////////////
//  clear error message
//
void CPrinterCtrl::m_ClearErrorMsg()
{
	m_LastErrorStr = "NO Error";
}

///////////////////////////////////////////////////////////
//  return error message
//
CString CPrinterCtrl::GetErrorMsg()
{
	return m_LastErrorStr;
}

