// PrinterCtrl.h: Interface of CPrinterCtrl class
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PRINTERCTRL_H__0227B9CD_9473_4D94_8AE7_B60640BAED8E__INCLUDED_)
#define AFX_PRINTERCTRL_H__0227B9CD_9473_4D94_8AE7_B60640BAED8E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <afxtempl.h>
#include "winspool.h"

//------------------------------------------------------------
//  define struct
//------------------------------------------------------------
typedef struct _PRINTER_INFO{
	CString PrinterName;		// Printer ICON Name.
	CString ModelName;			// Printer Model Name.
	CString PortName;			// Port Name of the Printer.
}PRINTER_INFO;

class CPrinterCtrl  
{
public:
	CString GetErrorMsg();		// the strings of last error message in thie class
	void ClearAllMember();		// initialize all member valiables
	CString TargetPrinterName;	// target printer name
	CString		DataFileName;	// data file name (full path)
	BOOL		EnumPrinters();	// enumerate printer name in this PC
	CPrinterCtrl();				// constructer
	virtual ~CPrinterCtrl();	// destructor
	
								// printer name and printer port
	CList<PRINTER_INFO, PRINTER_INFO> PrinterList;

private:
	void m_ClearErrorMsg();		// clear error message
	void m_GetErrorMsg();		// set error message
	CString m_LastErrorStr;		// string for error message
};

#endif // !defined(AFX_PRINTERCTRL_H__0227B9CD_9473_4D94_8AE7_B60640BAED8E__INCLUDED_)
