// StatusMonitorDlg.h : 
//

#if !defined(AFX_STATUSMONITORDLG_H__152E394C_2A17_4E85_BB57_329B39566D21__INCLUDED_)
#define AFX_STATUSMONITORDLG_H__152E394C_2A17_4E85_BB57_329B39566D21__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SubThread.h"
#include "PrinterCtrl.h"

/////////////////////////////////////////////////////////////////////////////
// CStatusMonitorDlg dialog

class CStatusMonitorDlg : public CDialog
{
// constructor
public:
	CStatusMonitorDlg(CWnd* pParent = NULL);	// constructor

// dialog data
	//{{AFX_DATA(CStatusMonitorDlg)
	enum { IDD = IDD_STATUSMONITOR_DIALOG };
	CStatic	m_Printer_Queue;
	CEdit	m_StarIOModelVersion;
	CStatic	m_Second;
	CButton	m_Status;
	CButton	m_SelectDevice;
	CButton	m_GetStatusFrame;
	CStatic	m_PortSetting;
	CStatic	m_Port;
	CStatic	m_IF;
	CStatic	m_PrinterPortLabel;
	CStatic	m_LabelRawData;
	CStatic	m_ETBCounter;
	CStatic	m_Presenterstate;
	CButton	m_GetModelVersion;
	CButton	m_DeviceReset;
	CButton	m_GetStatus;
	CComboBox	m_Interval;
	CEdit	m_StarIOPortSettings;
	CEdit	m_StarIOPort;
	CComboBox	m_StarIOIF;
	CEdit	m_PrinterPort;
	CComboBox	m_Printer;
	CEdit	m_ETBCounterText;
	CEdit	m_PresenterStateText;
	CComboBox	m_RawData;
	CButton	m_ETBavailable;
	CButton	m_Presenterpaperjam;
	CButton	m_BMerror;
	CButton	m_Papernearemptyinner;
	CButton	m_Paperempty;
	CButton	m_Headthermistorerror;
	CButton	m_Receivebufferoverflow;
	CButton	m_Commanderror;
	CButton	m_Voltageerror;
	CButton	m_Cuttererror;
	CButton	m_Unrecoverbleerror;
	CButton	m_Overtemperature;
	CButton	m_Coveropen;
	CButton	m_Printeroffline;
	CButton	m_PowerOff;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CStatusMonitorDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	//{{AFX_MSG(CStatusMonitorDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg LRESULT OnMsgFromSubThread1(WPARAM wParam, LPARAM lParam);
	afx_msg void OnBUTTONGetStatus();
	afx_msg void OnClose();
	afx_msg void OnBUTTONDeviceReset();
	afx_msg void OnRADIOPrinterDriver();
	afx_msg void OnRADIOStarIO();
	afx_msg void OnRADIOManual();
	afx_msg void OnRADIOInterval();
	afx_msg void OnSelchangeCOMBOPrinter();
	afx_msg void OnSelchangeCOMBOStarIOIF();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSelchangeCOMBOInterval();
	afx_msg void OnBUTTONGetModelVersion();
	virtual void OnOK();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	bool InitDeviceList(LPWSTR *pCommandLine,int pNumArgs);
	void StatusSet_PrinterPowerOnOff(bool);
	int	GetPrinterQueueList(void);
	void SelectPrinterQueueOrStarIO(bool);
	void SelectGetStatusManualOrInterval(bool);
	void m_FinProgram(void);
	void ShowStatus(void);
	void OnStartTimer(void);
	void OnStopTimer(void); 
	void SetWindowTitleNormal(void);
	void SetWindowTitleReading(void);
	void SetWindowTitleResetDevice(void);
	void SetWindowTitleReadModel(void);
	void SetPrinterPortBox(void);
	void GetStatusExecutePrinter(void);
	void GetStatusExecutePort(void);
	void GetStatusExecute(void);
	void SerarchPrinterQueue(LPCWSTR PrinterQueue);
	bool CheckPortNameStarIO();
	int SerarchPort(LPCWSTR clPortName);
	bool ModePrinter;
	bool PrinterPowerOn;
	bool GetStatusManual;
	CSubThread	m_SubThread1;
	StarPrinterStatus_2	StarPrinterStatus_d;
	CPrinterCtrl		m_PrinterCtrl;
	int	m_nTimer;
	CString PrinterName;
	int	TimerState;
	int	KeepStarIOPortType;

};

#define __TIMER_STATE_STOP	( 0x00 )
#define __TIMER_STATE_RUN	( 0x01 )

#define __TIMER_ID1	( 0x01 )

//TUP500
#define SMJPRINTER_LMPLUGREG_NAME    _T("SOFTWARE\\StarMicronics\\SMJLMHOST2\\Star TUP500 Presenter (TUP592)")    // TUP500 registry storage destination
#define SMJPRINTER_STLM_NAME         _T("\\stlm.dll")                                                     // Star Language Monitor
#define SMJPRINTER_STSMON_NAME       _T("\\stsmon.dll")                                                   // Star Status   Monitor

// stlm
BOOL WINAPI GetStarPrinterStatusA(LPCSTR queueName, StarPrinterStatus_2 * status);
BOOL WINAPI GetStarPrinterStatusW(LPCWSTR queueName, StarPrinterStatus_2 * status);


#ifdef UNICODE
#define GetStarPrinterStatus "GetStarPrinterStatusW"
typedef BOOL (WINAPI * STATUSCHK)(LPCWSTR, StarPrinterStatus_2 *);
#else
#define GetStarPrinterStatus "GetStarPrinterStatusA"
typedef BOOL (WINAPI * STATUSCHK)(LPCSTR,  StarPrinterStatus_2 *);
#endif // !UNICODE


//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_STATUSMONITORDLG_H__152E394C_2A17_4E85_BB57_329B39566D21__INCLUDED_)
